
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include "vector_io.h"

#define UNDEF -1

enum programming_method {
    greedy,
    dynamic_programming
};

// Un obiect este caracterizat de greutatea si valoarea sa.
struct MyObject {
    int weight;
    double value;
};

// Operator afisare pentru un obiect de tip MyObject. Afiseaza intai greutatea
// obiectului si apoi valoarea.
std::ostream& operator<<(std::ostream& stream, MyObject& obj)
{
    stream << obj.weight << ' ' << obj.value;

    return stream;
}

// Operator citire pentru un obiect de tip MyObject. Citeste intai greutatea
// obiectului si apoi valoarea.
std::istream& operator>>(std::istream& stream, MyObject& obj)
{
    stream >> obj.weight >> obj.value;

    return stream;
}


bool compare_unit_value(const MyObject& left, const MyObject& right)
{
    // TODO comparati obiectele left si right dupa valoarea lor unitara, adica
    // dupa raportul intre valoare si greutate. Dorim sa sortam crescator.

    
}

// Pentru abordarea Greedy se pot lua fragmente din fiecare obiect.
std::vector<std::pair<int, MyObject> > choose_objects_greedy(
        std::vector<MyObject> objects, int max_weight)
{
    // Solutia va fi constituita de un vector de perechi, fiecare pereche
    // continand obiectul ce a fost ales si cantitatea care a fost luata din
    // acesta.
    std::vector<std::pair<int, MyObject> > sol;

    // Sortam obiectele dupa valoarea unitara. Va trebui sa completati functia
    // de comparare.
    std::sort(objects.begin(), objects.end(), compare_unit_value);


    // TODO Selectati obiectele care incap in rucsac. Puteti lua fragmente
    // dintr-un obiect.

    

    return sol;
}

// Pentru Programare Dinamica se pot alege doar obiecte intregi.
std::vector<std::pair<int, MyObject> > choose_objects_pd(
        std::vector<MyObject> objects, int max_weight)
{
    // Solutia va fi constituita de un vector de perechi, fiecare pereche
    // continand obiectul ce a fost ales si cantitatea care a fost luata din
    // acesta.
    std::vector<std::pair<int, MyObject> > sol;

    // Matricea in care se va calcula rezultatul.
    //
    // val_max[i][j] reprezista valoarea maxima care se poate obtine pentru
    // greutatea j utilizand obiectele [0..i]
    std::vector<std::vector<int> > val_max(objects.size() + 1,
            std::vector<int>(max_weight + 1, UNDEF));

    // TODO Initializam prima coloana cu 0.
    


    // TODO Calculam pentru fiecare încarcare mai mica sau egala cu greutatea
    // maxima cea mai mare valoare pe care o putem obtine. Pentru aceasta,
    // avem nevoie de valorile pentru greutatile mai mici.
    //
    // Pentru a folosi fiecare obiect o singura data, consideram treptat toate
    // solutiile ce tin cont de primele {1, 2, ..., n} obiecte.
    //
    


    // TODO Cautam pe ultima linie a matricei valoarea maxima si salvam
    // indicele acesteia in variabila result.
    int result = UNDEF;
    

    // TODO Dupa ce am aflat pe ce pozitie se afla valoarea maxima care poate
    // fi atinsa, plecam de la pozitia maximului pentru a reconstitui solutia.
    

    return sol;
}

// Alege obiectele in functie de metoda dorita si afiseaza rezultatele
void test_case(std::vector<MyObject>& objects, int max_weight,
        programming_method method)
{
    std::vector<std::pair<int, MyObject> > sol;
    double total_value = 0;

    if (method == greedy) {
        sol = choose_objects_greedy(objects, max_weight);
    } else {
        sol = choose_objects_pd(objects, max_weight);
    }

    std::cout << "Au fost alese obiectele: " << std::endl << std::endl;
    for (unsigned int i = 0; i < sol.size(); i ++) {
        std::cout << "Greutate: " << sol[i].first << " Obiect: " <<
            sol[i].second << std::endl;
        total_value += sol[i].first * (sol[i].second.value /
                sol[i].second.weight);
    }

    std::cout << std::endl << "Valoare totala: " << total_value;
    std::cout << std::endl << std::endl << std::endl;
}

// Teste pentru metodele Greedy si Programare Dinamica
void test(std::vector<MyObject> test_greedy, int max_weight_greedy,
          std::vector<MyObject> test_pd, int max_weight_pd)
{
    std::cout << "==== Test Greedy ====" << std::endl << std::endl;
    test_case(test_greedy, max_weight_greedy, greedy);

    std::cout << "==== Test Programare Dinamica ====" << std::endl << std::endl;
    test_case(test_pd, max_weight_pd, dynamic_programming);
}


int main()
{
    std::ifstream f("date.in");

    // Seturi de obiecte pentru teste si greutatile maxime.
    std::vector<MyObject> test_greedy, test_pd;
    int max_weight_greedy, max_weight_pd;

    // Citire test Greedy.
    f >> max_weight_greedy >> test_greedy;

    // Citire test Programare Dinamica.
    f >> max_weight_pd >> test_pd;

    // Testare ambele variante.
    test(test_greedy, max_weight_greedy, test_pd, max_weight_pd);

    f.close();

    return 0;
}
